<?php

namespace CameraBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Camera.flash
 *
 * @ORM\Table(name="flash", schema="camera")
 * @ORM\Entity
 */
class Flash
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="SEQUENCE")
     * @ORM\SequenceGenerator(sequenceName="camera.flash_id_seq", allocationSize=1, initialValue=1)
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="brand", type="string", nullable=false)
     */
    private $brand;

    /**
     * @var string
     *
     * @ORM\Column(name="model", type="string", nullable=false)
     */
    private $model;

    /**
     * @var boolean
     *
     * @ORM\Column(name="is_auto_flash", type="boolean", nullable=false)
     */
    private $isAutoFlash = false;

    /**
     * @var boolean
     *
     * @ORM\Column(name="is_ttl", type="boolean", nullable=false)
     */
    private $isTtl = false;

    /**
     * @var string
     *
     * @ORM\Column(name="ttl_type", type="string", nullable=false)
     */
    private $ttlType = 'N / A';

    /**
     * @var boolean
     *
     * @ORM\Column(name="is_p_ttl", type="boolean", nullable=false)
     */
    private $isPTtl = false;

    /**
     * @var string
     *
     * @ORM\Column(name="p_ttl_type", type="string", nullable=false)
     */
    private $pTtlType = 'N / A';

    /**
     * @var string
     *
     * @ORM\Column(name="guide_number", type="string", nullable=true)
     */
    private $guideNumber;

    /**
     * @var string
     *
     * @ORM\Column(name="purchase_price", type="decimal", precision=10, scale=0, nullable=true)
     */
    private $purchasePrice;

    /**
     * @var string
     *
     * @ORM\Column(name="batteries", type="string", nullable=false)
     */
    private $batteries = '4x AA';

    /**
     * @var string
     *
     * @ORM\Column(name="notes", type="text", nullable=true)
     */
    private $notes;

    /**
     * @var string
     *
     * @ORM\Column(name="serial", type="string", nullable=true)
     */
    private $serial;



    /**
     * Get id
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set brand
     *
     * @param string $brand
     *
     * @return Flash
     */
    public function setBrand($brand)
    {
        $this->brand = $brand;

        return $this;
    }

    /**
     * Get brand
     *
     * @return string
     */
    public function getBrand()
    {
        return $this->brand;
    }

    /**
     * Set model
     *
     * @param string $model
     *
     * @return Flash
     */
    public function setModel($model)
    {
        $this->model = $model;

        return $this;
    }

    /**
     * Get model
     *
     * @return string
     */
    public function getModel()
    {
        return $this->model;
    }

    /**
     * Set isAutoFlash
     *
     * @param boolean $isAutoFlash
     *
     * @return Flash
     */
    public function setIsAutoFlash($isAutoFlash)
    {
        $this->isAutoFlash = $isAutoFlash;

        return $this;
    }

    /**
     * Get isAutoFlash
     *
     * @return boolean
     */
    public function getIsAutoFlash()
    {
        return $this->isAutoFlash;
    }

    /**
     * Set isTtl
     *
     * @param boolean $isTtl
     *
     * @return Flash
     */
    public function setIsTtl($isTtl)
    {
        $this->isTtl = $isTtl;

        return $this;
    }

    /**
     * Get isTtl
     *
     * @return boolean
     */
    public function getIsTtl()
    {
        return $this->isTtl;
    }

    /**
     * Set ttlType
     *
     * @param string $ttlType
     *
     * @return Flash
     */
    public function setTtlType($ttlType)
    {
        $this->ttlType = $ttlType;

        return $this;
    }

    /**
     * Get ttlType
     *
     * @return string
     */
    public function getTtlType()
    {
        return $this->ttlType;
    }

    /**
     * Set isPTtl
     *
     * @param boolean $isPTtl
     *
     * @return Flash
     */
    public function setIsPTtl($isPTtl)
    {
        $this->isPTtl = $isPTtl;

        return $this;
    }

    /**
     * Get isPTtl
     *
     * @return boolean
     */
    public function getIsPTtl()
    {
        return $this->isPTtl;
    }

    /**
     * Set pTtlType
     *
     * @param string $pTtlType
     *
     * @return Flash
     */
    public function setPTtlType($pTtlType)
    {
        $this->pTtlType = $pTtlType;

        return $this;
    }

    /**
     * Get pTtlType
     *
     * @return string
     */
    public function getPTtlType()
    {
        return $this->pTtlType;
    }

    /**
     * Set guideNumber
     *
     * @param string $guideNumber
     *
     * @return Flash
     */
    public function setGuideNumber($guideNumber)
    {
        $this->guideNumber = $guideNumber;

        return $this;
    }

    /**
     * Get guideNumber
     *
     * @return string
     */
    public function getGuideNumber()
    {
        return $this->guideNumber;
    }

    /**
     * Set purchasePrice
     *
     * @param string $purchasePrice
     *
     * @return Camera
     */
    public function setPurchasePrice($purchasePrice)
    {
        $this->purchasePrice = $purchasePrice ?? 0;

        return $this;
    }

    /**
     * Get purchasePrice
     *
     * @return string
     */
    public function getPurchasePrice()
    {
        return (double) str_replace('$', '', (string)$this->purchasePrice) ?? 0;
    }

    /**
     * Set batteries
     *
     * @param string $batteries
     *
     * @return Flash
     */
    public function setBatteries($batteries)
    {
        $this->batteries = $batteries;

        return $this;
    }

    /**
     * Get batteries
     *
     * @return string
     */
    public function getBatteries()
    {
        return $this->batteries;
    }

    /**
     * Set notes
     *
     * @param string $notes
     *
     * @return Flash
     */
    public function setNotes($notes)
    {
        $this->notes = $notes;

        return $this;
    }

    /**
     * Get notes
     *
     * @return string
     */
    public function getNotes()
    {
        return $this->notes;
    }

    /**
     * Set serial
     *
     * @param string $serial
     *
     * @return Flash
     */
    public function setSerial($serial)
    {
        $this->serial = $serial;

        return $this;
    }

    /**
     * Get serial
     *
     * @return string
     */
    public function getSerial()
    {
        return $this->serial;
    }
}
