<?php

namespace CameraBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Camera.lenses
 *
 * @ORM\Table(name="lenses", schema="camera")
 * @ORM\Entity
 */
class Lenses
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="SEQUENCE")
     * @ORM\SequenceGenerator(sequenceName="camera.lenses_id_seq", allocationSize=1, initialValue=1)
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="brand", type="string", length=64, nullable=true)
     */
    private $brand;

    /**
     * @var string
     *
     * @ORM\Column(name="coatings", type="string", length=64, nullable=true)
     */
    private $coatings;

    /**
     * @var string
     *
     * @ORM\Column(name="product_line", type="string", length=64, nullable=true)
     */
    private $productLine;

    /**
     * @var string
     *
     * @ORM\Column(name="model", type="string", length=64, nullable=true)
     */
    private $model;

    /**
     * @var string
     *
     * @ORM\Column(name="min_f_stop", type="string", length=10, nullable=true)
     */
    private $minFStop;

    /**
     * @var float
     *
     * @ORM\Column(name="max_f_stop", type="float", precision=10, scale=0, nullable=true)
     */
    private $maxFStop;

    /**
     * @var integer
     *
     * @ORM\Column(name="min_focal_length", type="integer", nullable=true)
     */
    private $minFocalLength;

    /**
     * @var integer
     *
     * @ORM\Column(name="max_focal_length", type="integer", nullable=true)
     */
    private $maxFocalLength;

    /**
     * @var string
     *
     * @ORM\Column(name="serial", type="string", length=10, nullable=true)
     */
    private $serial;

    /**
     * @var string
     *
     * @ORM\Column(name="purchase_price", type="decimal", precision=10, scale=0, nullable=true)
     */
    private $purchasePrice;

    /**
     * @var string
     *
     * @ORM\Column(name="notes", type="text", nullable=true)
     */
    private $notes;

    /**
     * @var string
     *
     * @ORM\Column(name="mount", type="string", length=40, nullable=true)
     */
    private $mount;

    /**
     * @var boolean
     *
     * @ORM\Column(name="received", type="boolean", nullable=false)
     */
    private $received = false;

    /**
     * @var boolean
     *
     * @ORM\Column(name="formerly_owned", type="boolean", nullable=false)
     */
    private $formerlyOwned = false;

    /**
     * @var string
     *
     * @ORM\Column(name="front_filter_size", type="decimal", precision=10, scale=0, nullable=true)
     */
    private $frontFilterSize;

    /**
     * @var string
     *
     * @ORM\Column(name="rear_filter_size", type="decimal", precision=10, scale=0, nullable=true)
     */
    private $rearFilterSize;

    /**
     * @var boolean
     *
     * @ORM\Column(name="is_teleconverter", type="boolean", nullable=false)
     */
    private $isTeleconverter = false;

    /**
     * @var integer
     *
     * @ORM\Column(name="design_elements", type="smallint", nullable=true)
     */
    private $designElements;

    /**
     * @var integer
     *
     * @ORM\Column(name="design_groups", type="smallint", nullable=true)
     */
    private $designGroups;

    /**
     * @var integer
     *
     * @ORM\Column(name="aperture_blades", type="smallint", nullable=true)
     */
    private $apertureBlades;



    /**
     * Get id
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set brand
     *
     * @param string $brand
     *
     * @return Lenses
     */
    public function setBrand($brand)
    {
        $this->brand = $brand;

        return $this;
    }

    /**
     * Get brand
     *
     * @return string
     */
    public function getBrand()
    {
        return $this->brand;
    }

    /**
     * Set coatings
     *
     * @param string $coatings
     *
     * @return Lenses
     */
    public function setCoatings($coatings)
    {
        $this->coatings = $coatings;

        return $this;
    }

    /**
     * Get coatings
     *
     * @return string
     */
    public function getCoatings()
    {
        return $this->coatings;
    }

    /**
     * Set productLine
     *
     * @param string $productLine
     *
     * @return Lenses
     */
    public function setProductLine($productLine)
    {
        $this->productLine = $productLine;

        return $this;
    }

    /**
     * Get productLine
     *
     * @return string
     */
    public function getProductLine()
    {
        return $this->productLine;
    }

    /**
     * Set model
     *
     * @param string $model
     *
     * @return Lenses
     */
    public function setModel($model)
    {
        $this->model = $model;

        return $this;
    }

    /**
     * Get model
     *
     * @return string
     */
    public function getModel()
    {
        return $this->model;
    }

    /**
     * Set minFStop
     *
     * @param string $minFStop
     *
     * @return Lenses
     */
    public function setMinFStop($minFStop)
    {
        $this->minFStop = $minFStop;

        return $this;
    }

    /**
     * Get minFStop
     *
     * @return string
     */
    public function getMinFStop()
    {
        return $this->minFStop;
    }

    /**
     * Set maxFStop
     *
     * @param float $maxFStop
     *
     * @return Lenses
     */
    public function setMaxFStop($maxFStop)
    {
        $this->maxFStop = $maxFStop;

        return $this;
    }

    /**
     * Get maxFStop
     *
     * @return float
     */
    public function getMaxFStop()
    {
        return $this->maxFStop;
    }

    /**
     * Set minFocalLength
     *
     * @param integer $minFocalLength
     *
     * @return Lenses
     */
    public function setMinFocalLength($minFocalLength)
    {
        $this->minFocalLength = $minFocalLength;

        return $this;
    }

    /**
     * Get minFocalLength
     *
     * @return integer
     */
    public function getMinFocalLength()
    {
        return $this->minFocalLength;
    }

    /**
     * Set maxFocalLength
     *
     * @param integer $maxFocalLength
     *
     * @return Lenses
     */
    public function setMaxFocalLength($maxFocalLength)
    {
        $this->maxFocalLength = $maxFocalLength;

        return $this;
    }

    /**
     * Get maxFocalLength
     *
     * @return integer
     */
    public function getMaxFocalLength()
    {
        return $this->maxFocalLength;
    }

    /**
     * Set serial
     *
     * @param string $serial
     *
     * @return Lenses
     */
    public function setSerial($serial)
    {
        $this->serial = $serial;

        return $this;
    }

    /**
     * Get serial
     *
     * @return string
     */
    public function getSerial()
    {
        return $this->serial;
    }

    /**
     * Set purchasePrice
     *
     * @param string $purchasePrice
     *
     * @return Camera
     */
    public function setPurchasePrice($purchasePrice)
    {
        $this->purchasePrice = $purchasePrice ?? 0;

        return $this;
    }

    /**
     * Get purchasePrice
     *
     * @return string
     */
    public function getPurchasePrice()
    {
        return (double) str_replace('$', '', (string)$this->purchasePrice) ?? 0;
    }

    /**
     * Set notes
     *
     * @param string $notes
     *
     * @return Lenses
     */
    public function setNotes($notes)
    {
        $this->notes = $notes;

        return $this;
    }

    /**
     * Get notes
     *
     * @return string
     */
    public function getNotes()
    {
        return $this->notes;
    }

    /**
     * Set mount
     *
     * @param string $mount
     *
     * @return Lenses
     */
    public function setMount($mount)
    {
        $this->mount = $mount;

        return $this;
    }

    /**
     * Get mount
     *
     * @return string
     */
    public function getMount()
    {
        return $this->mount;
    }

    /**
     * Set received
     *
     * @param boolean $received
     *
     * @return Lenses
     */
    public function setReceived($received)
    {
        $this->received = $received;

        return $this;
    }

    /**
     * Get received
     *
     * @return boolean
     */
    public function getReceived()
    {
        return $this->received;
    }

    /**
     * Set formerlyOwned
     *
     * @param boolean $formerlyOwned
     *
     * @return Lenses
     */
    public function setFormerlyOwned($formerlyOwned)
    {
        $this->formerlyOwned = $formerlyOwned;

        return $this;
    }

    /**
     * Get formerlyOwned
     *
     * @return boolean
     */
    public function getFormerlyOwned()
    {
        return $this->formerlyOwned;
    }

    /**
     * Set frontFilterSize
     *
     * @param string $frontFilterSize
     *
     * @return Lenses
     */
    public function setFrontFilterSize($frontFilterSize)
    {
        $this->frontFilterSize = $frontFilterSize;

        return $this;
    }

    /**
     * Get frontFilterSize
     *
     * @return string
     */
    public function getFrontFilterSize()
    {
        return $this->frontFilterSize;
    }

    /**
     * Set rearFilterSize
     *
     * @param string $rearFilterSize
     *
     * @return Lenses
     */
    public function setRearFilterSize($rearFilterSize)
    {
        $this->rearFilterSize = $rearFilterSize;

        return $this;
    }

    /**
     * Get rearFilterSize
     *
     * @return string
     */
    public function getRearFilterSize()
    {
        return $this->rearFilterSize;
    }

    /**
     * Set isTeleconverter
     *
     * @param boolean $isTeleconverter
     *
     * @return Lenses
     */
    public function setIsTeleconverter($isTeleconverter)
    {
        $this->isTeleconverter = $isTeleconverter;

        return $this;
    }

    /**
     * Get isTeleconverter
     *
     * @return boolean
     */
    public function getIsTeleconverter()
    {
        return $this->isTeleconverter;
    }

    /**
     * Set designElements
     *
     * @param integer $designElements
     *
     * @return Lenses
     */
    public function setDesignElements($designElements)
    {
        $this->designElements = $designElements;

        return $this;
    }

    /**
     * Get designElements
     *
     * @return integer
     */
    public function getDesignElements()
    {
        return $this->designElements;
    }

    /**
     * Set designGroups
     *
     * @param integer $designGroups
     *
     * @return Lenses
     */
    public function setDesignGroups($designGroups)
    {
        $this->designGroups = $designGroups;

        return $this;
    }

    /**
     * Get designGroups
     *
     * @return integer
     */
    public function getDesignGroups()
    {
        return $this->designGroups;
    }

    /**
     * Set apertureBlades
     *
     * @param integer $apertureBlades
     *
     * @return Lenses
     */
    public function setApertureBlades($apertureBlades)
    {
        $this->apertureBlades = $apertureBlades;

        return $this;
    }

    /**
     * Get apertureBlades
     *
     * @return integer
     */
    public function getApertureBlades()
    {
        return $this->apertureBlades;
    }
}
